diff -Nru t1lib-grace/T1lib/type1/type1.c t1lib-deb/T1lib/type1/type1.c
--- t1lib-grace/T1lib/type1/type1.c	2001-02-19 13:43:34.000000000 -0800
+++ t1lib-deb/T1lib/type1/type1.c	2014-03-27 20:23:42.310776026 -0700
@@ -1418,31 +1727,55 @@
 static int RRCurveTo(dx1, dy1, dx2, dy2, dx3, dy3)
   DOUBLE dx1, dy1, dx2, dy2, dx3, dy3;
 {
-  struct segment *B, *C, *D;
- 
-  IfTrace4((FontDebug), "RRCurveTo %f %f %f %f ", dx1, dy1, dx2, dy2);
-  IfTrace2((FontDebug), "%f %f\n", dx3, dy3);
- 
-  B = Loc(CharSpace, dx1, dy1);
-  C = Loc(CharSpace, dx2, dy2);
-  D = Loc(CharSpace, dx3, dy3);
- 
-  if (ProcessHints) {
-    /* For a Bezier curve, we apply the full hint value to
-       the Bezier C point (and thereby D point). */
-    currx += dx1 + dx2 + dx3;
-    curry += dy1 + dy2 + dy3;
-    /* C = Join(C, FindStems(currx, curry)); */
-    C = Join(C, FindStems(currx, curry, dx3, dy3));
-  }
- 
-  /* Since XIMAGER is not completely relative, */
-  /* we need to add up the delta values */
- 
-  C = Join(C, Dup(B));
-  D = Join(D, Dup(C));
- 
-  path = Join(path, Bezier(B, C, D));
+  long pindex = 0;
+  
+  /* compute hinting for previous point! */
+  if (ppoints == NULL || numppoints < 2) Error0i("RRCurveTo: No previous point!\n");
+  FindStems( currx, curry, currx-ppoints[numppoints-2].x, curry-ppoints[numppoints-2].y, dx1, dy1);
+
+  /* Allocate three new path points and pre-setup data */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx + dx1;
+  ppoints[pindex].y       = curry + dy1;
+  ppoints[pindex].ax      = ppoints[pindex].x;
+  ppoints[pindex].ay      = ppoints[pindex].y;
+  ppoints[pindex].type    = PPOINT_BEZIER_B;
+  ppoints[pindex].hinted  = 0;
+
+  /* update ideal position */
+  currx                  += dx1;
+  curry                  += dy1;
+
+  /* compute hinting for previous point! */
+  FindStems( currx, curry, currx-ppoints[numppoints-2].x, curry-ppoints[numppoints-2].y, dx2, dy2);
+
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx + dx2;
+  ppoints[pindex].y       = curry + dy2;
+  ppoints[pindex].ax      = ppoints[pindex].x;
+  ppoints[pindex].ay      = ppoints[pindex].y;
+  ppoints[pindex].type    = PPOINT_BEZIER_C;
+  ppoints[pindex].hinted  = 0;
+
+  /* update ideal position */
+  currx                  += dx2;
+  curry                  += dy2;
+
+  /* compute hinting for previous point! */
+  FindStems( currx, curry, currx-ppoints[numppoints-2].x, curry-ppoints[numppoints-2].y, dx3, dy3);
+
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx + dx3;
+  ppoints[pindex].y       = curry + dy3;
+  ppoints[pindex].ax      = ppoints[pindex].x;
+  ppoints[pindex].ay      = ppoints[pindex].y;
+  ppoints[pindex].type    = PPOINT_BEZIER_D;
+  ppoints[pindex].hinted  = 0;
+
+  /* update ideal position */
+  currx                  += dx3;
+  curry                  += dy3;
+
   return(0);
 }
  
@@ -1451,12 +1784,52 @@
 /* current point */
 static int DoClosePath()
 {
-  struct segment *CurrentPoint;
- 
-  IfTrace0((FontDebug), "DoClosePath\n");
-  CurrentPoint = Phantom(path);
-  path = ClosePath(path);
-  path = Join(Snap(path), CurrentPoint);
+  long pindex = 0;
+  long i = 0;
+  long tmpind;
+  double deltax = 0.0;
+  double deltay = 0.0;
+ 
+  if (ppoints == NULL || numppoints < 1) Error0i("DoClosePath: No previous point!");
+ 
+  /* If this ClosePath command together with the starting point of this
+     path completes to a segment aligned to a stem, we would miss
+     hinting for this point. --> Check and explicitly care for this! */
+  /* 1. Step back in the point list to the last moveto-point */
+  i = numppoints - 1;
+  while ( (i > 0) && (ppoints[i].type != PPOINT_MOVE ) ) { 
+    --i; 
+  }
+  
+  /* 2. Re-hint starting point and hint current point */
+  if ( ppoints[i].type == PPOINT_MOVE) {
+    deltax = ppoints[i].x - ppoints[numppoints-1].x;
+    deltay = ppoints[i].y - ppoints[numppoints-1].y;
+
+    if (ppoints == NULL || numppoints <= i + 1) Error0i("DoClosePath: No previous point!");
+    /* save nummppoints and reset to move point */
+    tmpind = numppoints;
+    numppoints = i + 1;
+    
+    /* re-hint starting point of current subpath (uses the value of numppoints!) */
+    FindStems( ppoints[i].x, ppoints[i].y, deltax, deltay,
+	       ppoints[i+1].x-ppoints[i].x, ppoints[i+1].y-ppoints[i].y);
+
+    /* restore numppoints and setup hinting for current point */
+    numppoints = tmpind;
+    FindStems( currx, curry, currx-ppoints[numppoints-2].x, curry-ppoints[numppoints-2].y,
+	       deltax, deltay);
+  }
+  
+  /* Allocate a new path point and pre-setup data */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx;
+  ppoints[pindex].y       = curry;
+  ppoints[pindex].ax      = ppoints[pindex-1].x;
+  ppoints[pindex].ay      = ppoints[pindex-1].y;
+  ppoints[pindex].type    = PPOINT_CLOSEPATH;
+  ppoints[pindex].hinted  = 0;
+
   return(0);
 }
  
@@ -1466,7 +1839,7 @@
 static int CallSubr(subrno)
   int subrno;
 {
-  IfTrace1((FontDebug), "CallSubr %d\n", subrno);
+  IfTrace2((FontDebug), "CallSubr %d (CallStackSize=%d)\n", subrno, CallTop);
   if ((subrno < 0) || (subrno >= SubrsP->len))
     Error0i("CallSubr: subrno out of range\n");
   PushCall(CharStringP, strindex, r);
@@ -1495,16 +1868,26 @@
 /* font dictionary */
 static int EndChar()
 {
+  long pindex = 0;
+  
   IfTrace0((FontDebug), "EndChar\n");
  
   /* There is no need to compute and set bounding box for
      the cache, since XIMAGER does that on the fly. */
  
-  /* Perform a Closepath just in case the command was left out */
-  path = ClosePath(path);
- 
-  /* Set character width */
-  path = Join(Snap(path), Loc(CharSpace, escapementX, escapementY));
+  /* Allocate a new path point and pre-setup data.
+     Note: For this special case, we use the variables that usually
+     store hinted coordinates for the escapement of the character.
+     It is required in handleCurrentSegment().
+  */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx;
+  ppoints[pindex].y       = curry;
+  ppoints[pindex].ax      = escapementX;
+  ppoints[pindex].ay      = escapementY;
+  ppoints[pindex].type    = PPOINT_ENDCHAR;
+  ppoints[pindex].hinted  = -1;
+
   return(0);
  
 }
@@ -1514,21 +1897,38 @@
 static int RMoveTo(dx,dy)
   DOUBLE dx,dy;
 {
-  struct segment *B;
- 
-  IfTrace2((FontDebug), "RMoveTo %f %f\n", dx, dy);
- 
-  B = Loc(CharSpace, dx, dy);
- 
-  if (ProcessHints) {
-    currx += dx;
-    curry += dy;
-    /* B = Join(B, FindStems(currx, curry)); */
-    B = Join(B, FindStems(currx, curry, 0.0, 0.0));
+  long pindex = 0;
+
+  /* Compute hinting for this path point! */
+  if ( numppoints == 1 ) {
+    /* Since RMoveTo for this case starts a new path segment
+       (flex-constructs have already been handled), the current
+       point is hinted here only taking the next point into account,
+       but not the previous. Later on, in DoClosePath(), we'll step
+       back to this point and the position might be rehinted. */
+    FindStems( currx, curry, 0, 0, dx, dy);
   }
- 
-  path = Join(path, B);
-  return(0);
+  else {
+    if (ppoints == NULL || numppoints < 2) Error0i("RMoveTo: No previous point!\n");
+    FindStems( currx, curry, ppoints[numppoints-2].x, ppoints[numppoints-2].y, dx, dy);
+  }
+  
+
+
+  /* Allocate a new path point and pre-setup data */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx + dx;
+  ppoints[pindex].y       = curry + dy;
+  ppoints[pindex].ax      = ppoints[pindex].x;
+  ppoints[pindex].ay      = ppoints[pindex].y;
+  ppoints[pindex].type    = PPOINT_MOVE;
+  ppoints[pindex].hinted  = 0;
+
+  /* update ideal position */
+  currx                  += dx;
+  curry                  += dy;
+  
+  return 0;
 }
  
 /* - DOTSECTION |- */
@@ -1548,8 +1948,12 @@
   unsigned char bchar, achar;
 {
   int Code;
-  struct segment *mypath;
- 
+  long pindex = 0;
+  
+  isseac      = 1;
+  seacaccent  = achar;
+  seacbase    = bchar;
+
   IfTrace4((FontDebug), "SEAC %f %f %f %d ", asb, adx, ady, bchar);
   IfTrace1((FontDebug), "%d\n", achar);
  
@@ -1558,9 +1962,9 @@
   /* The variables accentoffsetX/Y modify sidebearingX/Y in Sbw(). */
   /* Note that these incorporate the base character's sidebearing shift by */
   /* using the current sidebearingX, Y values. */
-  accentoffsetX = sidebearingX + adx - asb;
-  accentoffsetY = sidebearingY + ady;
- 
+  accentoffsetX = adx - asb;
+  accentoffsetY = ady;
+
   /* Set path = NULL to avoid complaints from Sbw(). */
   path = NULL;
  
@@ -1580,10 +1984,18 @@
     Decode(Code);
     if (errflag) return(0);
   }
-  /* Copy snapped path to mypath and set path to NULL as above. */
-  mypath = Snap(path);
-  path = NULL;
- 
+
+  /* Allocate a new path point. Data in this case is not relevant
+     in handleSegment(), we merely insert a snap() in order to return
+     to origin of the accent char. */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = accentoffsetX;
+  ppoints[pindex].y       = accentoffsetY;
+  ppoints[pindex].ax      = accentoffsetX;
+  ppoints[pindex].ay      = accentoffsetY;
+  ppoints[pindex].type    = PPOINT_SEAC;
+  ppoints[pindex].hinted  = 0;
+
   /* We must reset these to null now. */
   accentoffsetX = accentoffsetY = 0;
  
@@ -1595,7 +2007,6 @@
   ClearPSFakeStack();
   ClearCallStack();
  
-  FinitStems();
   InitStems();
  
   for (;;) {
@@ -1603,7 +2014,7 @@
     Decode(Code);
     if (errflag) return(0);
   }
-  path = Join(mypath, path);
+
   return(0);
 }
  
@@ -1614,6 +2025,9 @@
 static int Sbw(sbx, sby, wx, wy)
   DOUBLE sbx, sby, wx, wy;
 {
+  long pindex = 0;
+  
+  
   IfTrace4((FontDebug), "SBW %f %f %f %f\n", sbx, sby, wx, wy);
  
   escapementX = wx; /* Character width vector */
@@ -1623,8 +2037,29 @@
   sidebearingX = sbx + accentoffsetX;
   sidebearingY = sby + accentoffsetY;
  
+  currx = sidebearingX;
+  curry = sidebearingY;
+  /*
   path = Join(path, Loc(CharSpace, sidebearingX, sidebearingY));
-  if (ProcessHints) {currx = sidebearingX; curry = sidebearingY;}
+  if (ProcessHints) {
+    hcurrx = sidebearingX;
+    hcurry = sidebearingY;
+  }
+  */
+  
+  /* Allocate a path point and setup.
+     Note: In this special case, we store the char escapement in the members
+           ax and ay. They are required in handleCurrentSegment(). Hinting
+	   is not required for SBW, anyhow!
+  */
+  pindex = nextPPoint();
+  ppoints[pindex].x       = currx;
+  ppoints[pindex].y       = curry;
+  ppoints[pindex].ax      = wx;
+  ppoints[pindex].ay      = wy;
+  ppoints[pindex].type    = PPOINT_SBW;
+  ppoints[pindex].hinted  = -1; /* indicate that point is not to be hinted */
+ 
   return(0);
 }
  
@@ -1675,24 +2110,6 @@
  
 #define PaintType (0)
  
-#define lineto(x,y) { \
-  struct segment *CurrentPoint; \
-  DOUBLE CurrentX, CurrentY; \
-  CurrentPoint = Phantom(path); \
-  QueryLoc(CurrentPoint, CharSpace, &CurrentX, &CurrentY); \
-  Destroy(CurrentPoint); \
-  RLineTo(x - CurrentX, y - CurrentY); \
-}
- 
-#define curveto(x0,y0,x1,y1,x2,y2) { \
-  struct segment *CurrentPoint; \
-  DOUBLE CurrentX, CurrentY; \
-  CurrentPoint = Phantom(path); \
-  QueryLoc(CurrentPoint, CharSpace, &CurrentX, &CurrentY); \
-  Destroy(CurrentPoint); \
-  RRCurveTo(x0 - CurrentX, y0 - CurrentY, x1 - x0, y1 - y0, x2 - x1, y2 - y1); \
-}
- 
 #define xshrink(x) ((x - c4x2) * shrink +c4x2)
 #define yshrink(y) ((y - c4y2) * shrink +c4y2)
  
@@ -1741,9 +2158,16 @@
   DOUBLE eShift;
   DOUBLE cx, cy;
   DOUBLE ex, ey;
- 
-  Destroy(path);
-  path = FlxOldPath; /* Restore previous path (stored in FlxProc1) */
+
+  if (ppoints == NULL || numppoints < 8) Error0v("FlxProc: No previous point!");
+
+  /* Our PPOINT list now contains 7 moveto commands which
+     are about to be consumed by the Flex mechanism. --> Remove these
+     seven elements (their values already reside on the PSFakeStack!)
+     and approriately restore the current accumulated position. */
+  numppoints -= 7;
+  currx = ppoints[numppoints-1].x;
+  curry = ppoints[numppoints-1].y;
  
   if (ProcessHints) {
     dmin = TYPE1_ABS(idmin) / 100.0; /* Minimum Flex height in pixels */
@@ -1865,15 +2289,25 @@
     }
  
     if (x2 == x5 || y2 == y5) {
-      lineto(x5, y5);
+      RLineTo( x5 - currx, y5 - curry); \
     } else {
-      curveto(x0, y0, x1, y1, x2, y2);
-      curveto(x3, y3, x4, y4, x5, y5);
+      RRCurveTo( x0 - currx, y0 - curry,
+		 x1 - x0, y1 - y0,
+		 x2 - x1,
+		 y2 - y1); 
+      RRCurveTo( x3 - currx, y3 - curry,
+		 x4 - x3, y4 - y3,
+		 x5 - x4, y5 - y4); 
     }
   } else { /* ProcessHints is off */
     PickCoords(FALSE); /* Pick original control points */
-    curveto(x0, y0, x1, y1, x2, y2);
-    curveto(x3, y3, x4, y4, x5, y5);
+    RRCurveTo( x0 - currx, y0 - curry,
+	       x1 - x0, y1 - y0,
+	       x2 - x1,
+	       y2 - y1); 
+    RRCurveTo( x3 - currx, y3 - curry,
+	       x4 - x3, y4 - y3,
+	       x5 - x4, y5 - y4); 
   }
  
   PSFakePush(epY);
@@ -1885,12 +2319,9 @@
 /*   Saves and clears path, then restores currentpoint */
 static void FlxProc1()
 {
-  struct segment *CurrentPoint;
- 
-  CurrentPoint = Phantom(path);
- 
-  FlxOldPath = path;
-  path = CurrentPoint;
+  /* Since we are now building the path point list,
+     there's nothing to do here! */
+  return;
 }
  
 /* FlxProc2() = OtherSubrs[2]; Part of Flex */
@@ -1898,16 +2329,10 @@
 /*   Returns currentpoint on stack          */
 static void FlxProc2()
 {
-  struct segment *CurrentPoint;
-  DOUBLE CurrentX, CurrentY;
- 
-  CurrentPoint = Phantom(path);
-  QueryLoc(CurrentPoint, CharSpace, &CurrentX, &CurrentY);
-  Destroy(CurrentPoint);
- 
+  if (ppoints == NULL || numppoints < 1) Error0v("FlxProc2: No previous point!");
   /* Push CurrentPoint on fake PostScript stack */
-  PSFakePush(CurrentX);
-  PSFakePush(CurrentY);
+  PSFakePush( ppoints[numppoints-1].x);
+  PSFakePush( ppoints[numppoints-1].y);
 }
  
 /* HintReplace() = OtherSubrs[3]; Hint Replacement            */
@@ -1988,12 +2413,43 @@
 			  psobj *charstrP, psobj *subrsP,
 			  psobj *osubrsP,
 			  struct blues_struct *bluesP,
-			  int *modeP, char *charname)
+			  int *modeP, char *charname,
+			  float strokewidth,
+			  int decodeonly)
 {
   int Code;
- 
-  path = NULL;
+  long i = 0;
+  
+  double xp, yp;
+#ifdef DUMPDEBUGPATH
+  char fnbuf[128];
+#endif
+  struct segment* p;
+
+  /* Reset SEAC querying variables */
+  isseac     = 0;
+  seacbase   = 0;
+  seacaccent = 0;
+  
+  /* Reset point list */
+  ppoints          = NULL;
+  numppoints       = 0;
+  numppointchunks  = 0;
+
+  /* disable hinting for stroking */
+  if ( strokewidth != 0.0f )
+    ProcessHints = 0;
+  
+  if ( env->fontInfoP[PAINTTYPE].value.data.integer == 1 )
+    ProcessHints = 0;
+
+  path    = NULL;
+  apath   = NULL;
   errflag = FALSE;
+
+  if ( S == NULL ) {
+    S=(struct XYspace *) IDENTITY;
+  }
  
   /* Make parameters available to all Type1 routines */
   currentchar=charname;
@@ -2005,7 +2461,24 @@
   ModeP = modeP;
  
   blues = bluesP;
- 
+
+  if ( decodeonly == 0 ) {
+    QuerySpace( S, &scxx, &scyx, &scxy, &scyy); /* Transformation matrix */
+    p = ILoc( S, 1, 0);
+    QueryLoc(p, IDENTITY, &xp, &yp);
+    up = FABS(xp);
+    
+    size = scxx * 1000.0;
+#ifdef DUMPDEBUGPATH
+    sprintf( fnbuf, "t1dump_%s_%f.eps", charname, size); 
+    psfile = fopen( fnbuf, "wb");
+    if ( psfile != NULL ) {
+      PSDumpProlog( psfile);
+      fprintf( psfile, "T1LibDict begin\n\ngsave\n%f t1SetupSize\nt1PreparePage\n", size);
+    }
+#endif
+  }
+
   /* compute the alignment zones */
   SetRasterFlags();
   ComputeAlignmentZones();
@@ -2014,22 +2487,77 @@
   ClearPSFakeStack();
   ClearCallStack();
   InitStems();
- 
-  currx = curry = 0;
+
+  /* reset variables */
+  currx = curry = 0.0;
+  hcurrx = hcurry = 0.0;
   escapementX = escapementY = 0;
   sidebearingX = sidebearingY = 0;
   accentoffsetX = accentoffsetY = 0;
   wsoffsetX = wsoffsetY = 0;           /* No shift to preserve whitspace. */
   wsset = 0;                           /* wsoffsetX,Y haven't been set yet. */
- 
+
   for (;;) {
     if (!DoRead(&Code)) break;
     Decode(Code);
     if (errflag) break;
   }
-  FinitStems();
 
-  /* Report a possible error: */
+  if ( decodeonly != 0 ) {
+    /* OK, character description is now on stack, finish ... */
+    return NULL;
+  }
+
+  /* We now have a point list in absolute charspace coordinates. Adjust
+     non-hinted points to suppress hinting artifacts and generate path. */
+  for ( i=0; i<numppoints; i++ ) {
+    if ( ppoints[i].type == PPOINT_BEZIER_D)
+      adjustBezier( i);
+  }
+  /* Create path elements */
+#if defined(DUMPDEBUGPATH) & defined(DUMPDEBUGPATHBOTH)
+  if ( env->fontInfoP[PAINTTYPE].value.data.integer == 0 ) {
+    /* For this special debug case, we generate both a filled and a stroked
+       path!. */
+      createStrokePath( strokewidth, SUBPATH_CLOSED);
+      createFillPath();
+  }
+  else if ( env->fontInfoP[PAINTTYPE].value.data.integer == 1 ) {
+    /* PaintType = 1 indicates stroked font. If strokewidth is 0.0f,
+       we stroke using the font's internal strokewidth. Otherwise, the
+       user supplied value is used. */
+    if ( strokewidth != 0.0f )
+      createStrokePath( strokewidth, SUBPATH_OPEN);
+    else
+      createStrokePath( env->fontInfoP[STROKEWIDTH].value.data.real, SUBPATH_OPEN);
+  }
+#else
+  if ( env->fontInfoP[PAINTTYPE].value.data.integer == 0 ) {
+    /* PaintType = 0 indicates filled font. Hence, a strokewidth value
+       other than 0.0 indicates the character is to be stroked instead
+       of to be filled. */
+    if ( strokewidth != 0.0f )
+      createStrokePath( strokewidth, SUBPATH_CLOSED);
+    else
+      createFillPath();
+  }
+  else if ( env->fontInfoP[PAINTTYPE].value.data.integer == 1 ) {
+    /* PaintType = 1 indicates stroked font. If strokewidth is 0.0f,
+       we stroke using the font's internal strokewidth. Otherwise, the
+       user supplied value is used. */
+    if ( strokewidth != 0.0f )
+      createStrokePath( strokewidth, SUBPATH_OPEN);
+    else
+      createStrokePath( env->fontInfoP[STROKEWIDTH].value.data.real, SUBPATH_OPEN);
+  }
+#endif
+  
+  /* check and handle accented char */
+  if ( apath != NULL ) {
+    path = Join( apath, path);
+  }
+  
+  /* Report a possible error: */
   *modeP=errflag;
   
   /* Clean up if an error has occurred */
@@ -2040,6 +2568,21 @@
     }
   }
  
+#ifdef DUMPDEBUGPATH
+  if ( psfile != NULL ) {
+    PSDumpEpilog( psfile);
+    fclose( psfile);
+    psfile = 0;
+  }
+#endif
+
+  /* Cleanup ppoints */
+  if ( ppoints != NULL ) {
+    free( ppoints);
+    ppoints = NULL;
+    numppoints = 0;
+  }
+  
   return((struct xobject *) path);
 }
  
@@ -2048,11 +2591,19 @@
 struct xobject *Type1Line(psfont *env, struct XYspace *S,
 			  float line_position,
 			  float line_thickness,
-			  float line_length)
+			  float line_length,
+			  float strokewidth)
 {
+
+  /* Reset point list */
+  ppoints          = NULL;
+  numppoints       = 0;
+  numppointchunks  = 0;
   
-  path = NULL;
+  path    = NULL;
+  apath   = NULL;
   errflag = FALSE;
+
   
   /* Make parameters available to all Type1 routines */
   Environment = (char *)env;
